﻿Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.Reflection
Imports System.Windows.Media
Imports System.Threading.Tasks
Imports System.Windows.Threading

Namespace Viewmodel
   Public Class Mainmodel : Inherits NotifyPropertyChanged
      Public Shared Instance As New Mainmodel
      Private _Timer As DispatcherTimer

      Public WithEvents Commands As New CommandTree

      Private __BrushKeys As Tuple(Of String, SolidColorBrush, ResourceKey)()
      Public WithEvents BrushKeys As ListCollectionView

      Private _SelectedBrushkeys As ResourceKey()
      Public Property SelectedBrushkeys() As ResourceKey()
         Get
            Return _SelectedBrushkeys
         End Get
         Set(value As ResourceKey())
            ChangePropIfDifferent(value, _SelectedBrushkeys)
         End Set
      End Property

      Private Sub New()
         Dim root = Commands("").AddFlow(AddressOf AutoRun)(AddressOf Test)("Mnu0")
         Commands("0").SetChecked(False)
         Commands("2").Add("Mnu0.0").Add("Mnu0.0.0")

         Dim props = GetType(System.Windows.SystemColors).GetProperties(BindingFlags.Static Or BindingFlags.Public)
         Dim brushKs = From mtd In props Where mtd.Name.EndsWith("BrushKey")
         Dim brushs = From mtd In props Where mtd.Name.EndsWith("Brush")

         Dim tpls = From b In brushs Join k In brushKs On b.Name Equals k.Name.Substring(0, k.Name.Length - 3)
                 Select Tuple.Create(k.Name, DirectCast(b.GetValue(Nothing), SolidColorBrush), DirectCast(k.GetValue(Nothing), ResourceKey))
         __BrushKeys = tpls.ToArray
         Dbg(Lf.Between(brushKs.ToArray(Function(p) p.Name.Between("<>"))))
         BrushKeys = New ListCollectionView(__BrushKeys)

         _Timer = New DispatcherTimer(TimeSpan.FromSeconds(0.5), DispatcherPriority.DataBind,
                                      Function(s, e) BrushKeys.MoveCurrentToNext() OrElse BrushKeys.MoveCurrentToFirst(), Dispatcher.CurrentDispatcher)
         AutoRun()
         BrushKeys.MoveCurrentToFirst()
      End Sub

      Private Sub Test()
      End Sub

      Private Sub BrushKeys_CurrentChanged(sender As Object, e As EventArgs) Handles BrushKeys.CurrentChanged
         If BrushKeys.IsCurrentAfterLast Then Return
         Dim tpl = __BrushKeys(BrushKeys.CurrentPosition)
         SelectedBrushkeys.Be({tpl.Item3})
      End Sub

      Private Sub AutoRun()
         _Timer.IsEnabled = Commands("0").IsChecked
      End Sub

   End Class

End Namespace