﻿#Region "FileHeader"
Imports System.Globalization
Imports System, System.Text
#If Nocompile Then
ParamListConverter(Of T) kann komma- oder space-separierte Strings in List(Of T) konvertieren. Hierzu bedient er sich des durch TypeDescriptor.GetConverter(GetType(T)) geholten TypeConverters. Leere StringSegmente werden ignoriert, ausser ein Erbe der Klasse hat einen DefaultItemString angegeben.
   Mit diesem TypeConverter kann man List(of T)-Properties attributieren, und die kann man dann im Xaml praktischerweise als Inline-Attribut zuweisen.
      siehe GridEx.RowDefs - Property
#End If
#End Region 'FileHeader

Namespace System.ComponentModel
#Region "FunktioniertNicht"

#If False Then

   Public Class ArrayConverter(Of T) : Inherits StringConverterBase
      Private _tpItem As Type = GetType(T)

      Public Sub New()
         Dim conv = TypeDescriptor.GetConverter(_tpItem)
         If conv.CanConvertFrom(tpString) AndAlso conv.CanConvertTo(tpString) Then
            _ItemFromString = AddressOf conv.ConvertFromInvariantString
            _ItemToString = AddressOf conv.ConvertToInvariantString
         End If
      End Sub

      Public Overrides Function ConvertFrom(context As ITypeDescriptorContext, culture As CultureInfo, value As Object) As Object
         Dim splits = DirectCast(value, String).Split(_SplitChars, StringSplitOptions.RemoveEmptyEntries)
         Dim itms(splits.Count - 1) As T
         For i = 0 To splits.Count - 1
            itms.SetValue(_ItemFromString(splits(i)), i)
         Next
         Return itms
      End Function
      Public Overrides Function ConvertTo(context As ITypeDescriptorContext, culture As CultureInfo, value As Object, destinationType As Type) As Object
         Dim itms = DirectCast(value, T())
         Dim sb = New StringBuilder
         For i = 0 To itms.Count - 1
            sb.Append(_ItemToString).Append(" "c)
         Next
         Return sb.ToString(0, sb.Length - 1)
      End Function
   End Class

   Public MustInherit Class StringConverterBase : Inherits TypeConverter
      Protected Shared _ItemFromString As Func(Of String, Object)
      Protected Shared _ItemToString As Func(Of Object, String)
      Protected Shared _SplitChars As Char() = " ,".ToCharArray
      Protected Shared tpString As Type = GetType(String)
      Protected Shared tpDest As Type = GetType(String)
      Protected Shared _SplitOption As StringSplitOptions = StringSplitOptions.RemoveEmptyEntries

      Public Overrides Function CanConvertFrom(context As ITypeDescriptorContext, sourceType As Type) As Boolean
         Return sourceType Is tpString AndAlso _ItemFromString.NotNull
      End Function
      Public Overrides Function CanConvertTo(context As ITypeDescriptorContext, destinationType As Type) As Boolean
         Return _ItemToString.NotNull
      End Function
   End Class
#End If
#End Region 'FunktioniertNicht

   Public Class ParamListConverter(Of T) : Inherits TypeConverter

      Protected Shared _ItemFromString As Converter(Of String, T)
      Protected Shared _ItemToString As Converter(Of T, String)
      Protected Shared _SplitChars As Char() = " ,".ToCharArray
      Protected Shared ReadOnly _tpString As Type = GetType(String)
      Protected Shared _SplitOption As StringSplitOptions = StringSplitOptions.RemoveEmptyEntries
      Protected Shared ReadOnly _Conv As TypeConverter

      Protected Shared _DefaultItemString As String

      Shared Sub New()
         _Conv = TypeDescriptor.GetConverter(GetType(T))
         Try
            If _Conv.CanConvertFrom(_tpString) AndAlso _Conv.CanConvertTo(_tpString) Then
               _ItemFromString = Function(s) DirectCast(_Conv.ConvertFromInvariantString(s), T)
               _ItemToString = AddressOf _Conv.ConvertToInvariantString
            End If
         Catch ex As Exception
         End Try
      End Sub

      Public Overrides Function CanConvertFrom(context As ITypeDescriptorContext, sourceType As Type) As Boolean
         Return sourceType Is _tpString AndAlso _ItemFromString.NotNull
      End Function
      Public Overrides Function CanConvertTo(context As ITypeDescriptorContext, destinationType As Type) As Boolean
         Return destinationType Is _tpString AndAlso _ItemToString.NotNull
      End Function
      Public Overrides Function ConvertFrom(context As ITypeDescriptorContext, culture As CultureInfo, value As Object) As Object
         Dim splits = DirectCast(value, String).Split(_SplitChars, _SplitOption)
         Return New List(Of T)(splits.ToArray(_ItemFromString))
      End Function
      Public Overrides Function ConvertTo(context As ITypeDescriptorContext, culture As CultureInfo, value As Object, destinationType As Type) As Object
         Return String.Join(" ", DirectCast(value, List(Of T)).ConvertAll(_ItemToString))
      End Function

   End Class

End Namespace