﻿#Region "FileHeader"
#If False Then
Alles selbsterklärend.
#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
#End Region 'FileHeader

Namespace System

   Public Class Tree(Of TNode As {Node(Of TNode), New}) : Inherits NotifyPropertyChanged

      Protected ReadOnly _Nodes As New TNode With {.Tree = Me}
      Public ReadOnly Property Nodes As TNode
         Get
            Return _Nodes
         End Get
      End Property

      Protected _SelectedNode As TNode
      Public Property SelectedNode() As TNode
         Get
            Return _SelectedNode
         End Get
         Set( value As TNode)
            ChangePropIfDifferent(value, _SelectedNode, "SelectedNode")
         End Set
      End Property


      Public Function FindNode(path As String) As TNode
         Using segments = path.Split(IO.Path.DirectorySeparatorChar).GetEnumeratorX
            Dim i = -1
            Dim parent = FindNode(segments, i)
            Return If(i < 0, Nothing, parent)
         End Using
      End Function

      ''' <summary> returns the with pathSegments qualified Node. If missing, it returns the Node, in which the path should be installed. Furthermore Index gets set to the Notted Index, where the path should be inserted. Furthermore the pathSegments-Enumerator references the first missing pathSegment </summary>
      Public Function FindNode(Of T As IEnumerator(Of String))(ByRef pathSegments As T, Optional ByRef index As Integer = -1) As TNode
         'normal könnte man byVal übergeben, aber der List(of T).Enumerator ist eine Structure
         index = -1
         Dim parent = _Nodes
         While pathSegments.MoveNext
            If parent.Count = 0 Then Exit While
            index = parent.FindIndexByName(pathSegments.Current)
            If index < 0 Then Exit While
            parent = parent(index)
         End While
         Return parent
      End Function

      ''' <summary> creates and inserts a new with path qualified Node. Parents will be created too, if missing </summary>
      Public Function InsertNewNode(path As String) As TNode
         Using segments = path.Split(IO.Path.DirectorySeparatorChar).GetEnumeratorX
            Dim i = -1
            Dim parent = FindNode(segments, i)
            If i >= 0 Then
               Msg("'", path, "' haben wir schon!")
               Return Nothing
            End If
            Return parent.InsertNewNodePath(Not i, segments)
         End Using
      End Function

      ''' <summary> reads the whole Tree into a List(Of TNode) </summary>
      Public Function ToList() As List(Of TNode)
         Dim lst = New List(Of TNode)(Nodes)
         For i = 0 To Integer.MaxValue
            If i = lst.Count Then Exit For
            lst.AddRange(lst(i))
         Next
         Return lst
      End Function

   End Class
End Namespace